#include <cstdio>
#include <cstdlib>
#include <cmath>

bool exists(int ct, int rt, int cmax, int rmax);
void distance(int** pole, int pc, int pr, int cmax, int rmax);

int main(){
	int r, c, gr, gc, lr, lc;
	r = c = gr = gc = lr = lc = 0;
	printf("AHOJ\n");
	if(scanf("%d %d %d %d %d %d\n", &r, &c, &gr, &gc, &lr, &lc) != 6) return 0;
	printf("R:%d C:%d gr:%d gc:%d lr:%d lc:%d\n", r, c, gr, gc, lr, lc);
	int** pole = (int**)malloc((c + 1) * sizeof(int*));
	for(int i = 0; i < c; i++){
		pole[i] = (int*)malloc((r + 1) * sizeof(int));
	}
	for(int i = 0; i < r; i++)
		for(int j = 0; j < c; j++)
			pole[j][i] = 2000000000;
	pole[lc][lr] = 0;
	printf("NAzdar\n");
	distance(pole, lc, lr, c, r);
	printf("%d\n", pole[gc][gr]);
	return 0;
}

bool exists(int ct, int rt, int cmax, int rmax){
	if((cmax < ct) || (rmax < rt) || (ct < 1) || (rt < 1)) return false;
	return true;
}

void distance(int** pole, int pc, int pr, int cmax, int rmax){
	for(int i = -2; i < 3; i++){
		if(i == 0) i++;
		for(int j = -2; j < 3; j++){
			if(j == 0) j++;
			if((abs(i) + abs(j) == 3) && exists(pc+i, pr+j, cmax, rmax)){
				if(pole[i+pc][j+pr] > (pole[pc][pr] + 1)){
					pole[i+pc][j+pr] = (pole[pc][pr] + 1);
					distance(pole, i+pc, j+pr, cmax, rmax);
				}
			}
		}
	}
}

